#include <path_utils.h>
#include <stdlib.h>
#include <string.h>

char* replace_extension(char* path, char* ext) {
    const char* last_dot = strrchr(path, '.');
    const char* last_slash = strrchr(path, '/');
#ifdef _WIN32
    const char* last_backslash = strrchr(path, '\\');
    if (!last_slash || (last_backslash && last_backslash > last_slash)) {
        last_slash = last_backslash;
    }
#endif

    if (last_dot && (!last_slash || last_dot > last_slash)) {
        size_t base_len = last_dot - path;
        size_t ext_len = strlen(ext);
        char* result = malloc(base_len + 1 + ext_len + 1);
        if (!result) {
            return NULL; // >.<
        }
        memcpy(result, path, base_len);
        result[base_len] = '\0';
        strcat(result, ".");
        strcat(result, ext);
        return result;
    }

    size_t len = strlen(path);
    size_t ext_len = strlen(ext);
    char* result = malloc(len + 1 + ext_len + 1);
    if (!result) {
        return NULL;
    }
    strcpy(result, path);
    strcat(result, ".");
    strcat(result, ext);
    return result;
}
